package gov.lbl.nest.jee.monitor;

import java.util.Date;
import java.util.Map;
import java.util.ServiceLoader;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import gov.lbl.nest.common.monitor.DefaultInstrumentationManager;
import gov.lbl.nest.common.monitor.Instrumentation;
import gov.lbl.nest.common.monitor.InstrumentationManager;
import gov.lbl.nest.common.monitor.Level;
import gov.lbl.nest.common.monitor.SimpleInstrumentation;

/**
 * This extends the {@link SimpleInstrumentation} class to use as
 * {@link InstrumentationManager} found by looking it up in the JNDI.
 * 
 * @author patton
 */
public class SimpleInstrumentationImpl extends
                                       SimpleInstrumentation {

    // public static final member data

    // protected static final member data

    // static final member data

    // private static final member data

    /**
     * The {@link Logger} used by this class.
     */
    private static final Logger LOG = LoggerFactory.getLogger(SimpleInstrumentationImpl.class);

    // private static member data

    // private instance member data

    /**
     * The {@link InstrumentationManager} used by this object.
     */
    private InstrumentationManager manager;

    // constructors

    /**
     * Constructor used by {@link ServiceLoader}.
     */
    public SimpleInstrumentationImpl() {
        super(null);
    }

    /**
     * Creates an instance of this class.
     * 
     * @param name
     *            the name that will form the basis for all event types generated by
     *            the resulting {@link Instrumentation} instance.
     */
    public SimpleInstrumentationImpl(String name) {
        super(name);
    }

    // instance member method (alphabetic)

    private void getSimpleInstrumentationManager() {
        if (null == manager) {
            try {
                Context ctx = new InitialContext();
                manager = (InstrumentationManager) ctx.lookup("java:global/spade/InstrumentationManagerImpl");
            } catch (NamingException e) {
                LOG.warn("Unable to locate the requested InstrumentationManager so will use the default");
                manager = new DefaultInstrumentationManager();
            }
        }
    }

    @Override
    protected void pointOfInterest(String type,
                                   Level level,
                                   Integer status,
                                   String guid,
                                   Map<String, String> attributes) {
        getSimpleInstrumentationManager();
        if (null == manager) {
            return;
        }
        manager.pointOfInterest(new Date(),
                                type,
                                level,
                                status,
                                guid,
                                attributes);
    }

    // static member methods (alphabetic)

    // Description of this object.
    // @Override
    // public String toString() {}

    // public static void main(String args[]) {}
}
